---
title: Localize a PDF Form
product: PDF Generator
description: This JavaScript demo demonstrates how to localize a PDF form by translating its content into different languages using a JSON schema, with examples available in English, German, Italian, French, and Spanish.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Localize a PDF Form (Vanilla JS)

Localization capabilities enable you to adapt a PDF form to the local language of the viewer. This demo shows how to translate PDF form content to any language. English, German, Italian, French, and Spanish are available as examples. Select one of these languages from the **Form language** drop-down menu and click the **Save as PDF** button to generate a localized PDF document.

To localize a PDF form, open its JSON schema and translate visible texts in it (titles, descriptions, choice texts, placeholders). Typically, properties that specify visible texts accept string values. Instead, specify the properties with objects. Each object field should indicate a locale and the field value&mdash;a translation for this locale. Refer to the survey JSON schema (the `json.js` file) for a code example.

To generate a localized PDF form, assign a required locale code to the `locale` property of the [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. For example, the following code applies the French locale:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";
```

Alternatively, you can specify the [`locale`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#locale) property within the survey JSON schema that you pass to the `SurveyPDF` instance:

```js
const surveyJson = {
  // ...
  "locale": "fr"
}
const pdfDocOptions = { /* ... */ };
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

> Default PDF fonts support only Latin-based languages. Other languages require [custom fonts](/pdf-generator/examples/special-characters-in-pdf-form/).

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.data = {
    "nps-score": 9,
    "promoter-features": [
        "performance",
        "ui"
    ],
    "rebuy": true,
    "testimonial": "yes",
    "email": "john.doe@example.org"
};
survey.locale = "it";
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "completedHtmlOnCondition": [
    {
      "expression": "{nps-score} <= 6 or {rebuy} = false",
      "html": {
        "default": "Thanks for your feedback! We highly value all ideas and suggestions from our customers, whether they're positive or critical. In the future, our team might reach out to you to learn more about how we can further improve our product so that it exceeds your expectations.",
        "fr": "Merci pour vos commentaires! Nous accordons une grande importance à toutes les idées et suggestions de nos clients, qu'elles soient positives ou critiques. À l'avenir, notre équipe pourrait vous contacter pour en savoir plus sur la façon dont nous pouvons encore améliorer notre produit afin qu'il dépasse vos attentes.",
        "de": "Vielen Dank für Ihr Feedback! Wir schätzen alle Ideen und Vorschläge unserer Kunden sehr, egal ob positiv oder kritisch. In Zukunft wird sich unser Team möglicherweise mit Ihnen in Verbindung setzen, um mehr darüber zu erfahren, wie wir unser Produkt weiter verbessern können, damit es Ihre Erwartungen übertrifft.",
        "es": "¡Gracias por tus comentarios! Valoramos mucho todas las ideas y sugerencias de nuestros clientes, ya sean positivas o críticas. En el futuro, nuestro equipo podría comunicarse con usted para obtener más información sobre cómo podemos mejorar aún más nuestro producto para que supere sus expectativas.",
        "it": "Grazie per il tuo feedback! Apprezziamo molto tutte le idee e i suggerimenti dei nostri clienti, siano essi positivi o critici. In futuro, il nostro team potrebbe contattarti per saperne di più su come possiamo migliorare ulteriormente il nostro prodotto in modo che superi le tue aspettative."
      }
    },
    {
      "expression": "{nps-score} = 6 or {nps-score} = 7",
      "html": {
        "default": "Thanks for your feedback. Our goal is to create the best possible product, and your thoughts, ideas, and suggestions play a major role in helping us identify opportunities to improve.",
        "fr": "Merci pour vos commentaires. Notre objectif est de créer le meilleur produit possible, et vos réflexions, idées et suggestions jouent un rôle majeur pour nous aider à identifier les opportunités d'amélioration.",
        "de": "Vielen Dank für Ihr Feedback. Unser Ziel ist es, das bestmögliche Produkt zu schaffen, und Ihre Gedanken, Ideen und Vorschläge spielen eine wichtige Rolle dabei, uns dabei zu helfen, Verbesserungsmöglichkeiten zu erkennen.",
        "es": "Gracias por tus comentarios. Nuestro objetivo es crear el mejor producto posible, y sus pensamientos, ideas y sugerencias juegan un papel importante para ayudarnos a identificar oportunidades para mejorar.",
        "it": "Grazie per il tuo feedback Il nostro obiettivo è creare il miglior prodotto possibile e i tuoi pensieri, idee e suggerimenti svolgono un ruolo importante nell'aiutarci a identificare le opportunità di miglioramento."
      }
    },
    {
      "expression": "{nps-score} >= 8",
      "html": {
        "default": "Thanks for your feedback. It's great to hear that you're a fan of our product. Your feedback helps us discover new opportunities to improve it and make sure you have the best possible experience.",
        "fr": "Merci pour vos commentaires. Nous sommes ravis d'entendre que vous avez apprécié notre produit. Vos commentaires nous aident à découvrir de nouvelles opportunités pour l'améliorer et vous assurer la meilleure expérience possible.",
        "de": "Vielen Dank für Ihr Feedback. Es ist schön zu hören, dass Sie ein Fan unseres Produkts sind. Ihr Feedback hilft uns, neue Verbesserungsmöglichkeiten zu entdecken und sicherzustellen, dass Sie das bestmögliche Erlebnis haben.",
        "es": "Gracias por tus comentarios. Es fantástico saber que eres fanático de nuestro producto. Sus comentarios nos ayudan a descubrir nuevas oportunidades para mejorarlo y asegurarnos de que tenga la mejor experiencia posible.",
        "it": "Grazie per il tuo feedback È bello sapere che sei un fan del nostro prodotto. Il tuo feedback ci aiuta a scoprire nuove opportunità per migliorarlo e assicurarci che tu abbia la migliore esperienza possibile."
      }
    }
  ],
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "rating",
          "name": "nps-score",
          "title": {
            "default": "On a scale from 0 to 10, how likely are you to recommend us to a friend or colleague?",
            "fr": "Sur une échelle de 0 à 10, quelle est la probabilité que vous recommandiez notre produit à un ami ou à un collègue?",
            "de": "Auf einer Skala von 0 bis 10, wie wahrscheinlich ist es, dass Sie uns einem Freund oder Kollegen weiterempfehlen?",
            "es": "En una escala de 0 a 10, ¿qué probabilidades hay de que nos recomiende a un amigo o colega?",
            "it": "Su una scala da 0 a 10, quanto è probabile che ci consiglieresti ad un amico o collega?"
          },
          "rateMin": 0,
          "rateMax": 10
        },
        {
          "type": "comment",
          "name": "disappointing-experience",
          "visibleIf": "{nps-score} <= 5",
          "title": {
            "default": "How did we disappoint you and what can we do to make things right?",
            "fr": "Nous n'avons pas été a la hauteur de vos attentes, comment pouvons-nous améliorer?",
            "de": "Wie haben wir Sie enttäuscht und was können wir tun, um die Dinge wieder in Ordnung zu bringen?",
            "es": "¿Cómo te decepcionamos y qué podemos hacer para arreglar las cosas?",
            "it": "In che modo ti abbiamo deluso e cosa possiamo fare per sistemare le cose?"
          },
          "maxLength": 300
        },
        {
          "type": "comment",
          "name": "improvements-required",
          "visibleIf": "{nps-score} >= 6",
          "title": {
            "default": "What can we do to make your experience more satisfying?",
            "fr": "Que pouvons-nous faire pour rendre votre expérience plus satisfaisante?",
            "de": "Was können wir tun, um Ihr Erlebnis zufriedenstellender zu gestalten?",
            "es": "¿Qué podemos hacer para que tu experiencia sea más satisfactoria?",
            "it": "Cosa possiamo fare per rendere la tua esperienza più soddisfacente?"
          },
          "maxLength": 300
        },
        {
          "type": "checkbox",
          "name": "promoter-features",
          "visibleIf": "{nps-score} >= 9",
          "title": {
            "default": "Which of the following features do you value the most?",
            "fr": "Laquelle des fonctionnalités suivantes appréciez-vous le plus ?",
            "de": "Welche der folgenden Funktionen schätzen Sie am meisten?",
            "es": "¿Cuál de las siguientes características valoras más?",
            "it": "Quale delle seguenti caratteristiche apprezzi di più?"
          },
          "description": {
            "default": "Please select no more than three features.",
            "fr": "Veuillez ne pas sélectionner plus de trois fonctionnalités.",
            "de": "Bitte wählen Sie nicht mehr als drei Funktionen aus.",
            "es": "Seleccione no más de tres funciones.",
            "it": "Seleziona non più di tre funzionalità."
          },
          "isRequired": true,
          "choices": [
            {
              "value": "performance",
              "text": {
                "default": "Performance",
                "de": "Leistung",
                "es": "Actuación",
                "it": "Prestazione"
              }
            },
            {
              "value": "stability",
              "text": {
                "default": "Stability",
                "fr": "Stabilité",
                "de": "Stabilität",
                "es": "Estabilidad",
                "it": "Stabilità"
              }
            },
            {
              "value": "ui",
              "text": {
                "default": "User interface",
                "fr": "Interface utilisateur",
                "de": "Benutzeroberfläche",
                "es": "Interfaz de usuario",
                "it": "Interfaccia utente"
              }
            },
            {
              "value": "complete-functionality",
              "text": {
                "default": "Complete functionality",
                "fr": "Ensemble des fonctionnalités",
                "de": "Vollständige Funktionalität",
                "es": "Funcionalidad completa",
                "it": "Funzionalità completa"
              }
            },
            {
              "value": "learning-materials",
              "text": {
                "default": "Learning materials (documentation, demos, code examples)",
                "fr": "Matériel d'apprentissage (documentation, démos, exemples de code)",
                "de": "Lernmaterialien (Dokumentation, Demos, Codebeispiele)",
                "es": "Materiales de aprendizaje (documentación, demostraciones, ejemplos de código)",
                "it": "Materiali didattici (documentazione, demo, esempi di codice)"
              }
            },
            {
              "value": "support",
              "text": {
                "default": "Quality support",
                "fr": "Accompagnement de qualité",
                "de": "Qualitätsunterstützung",
                "es": "Soporte de calidad",
                "it": "Supporto di qualità"
              }
            }
          ],
          "showOtherItem": true,
          "otherPlaceholder": {
            "default": "Please specify...",
            "fr": "Veuillez préciser...",
            "de": "Bitte angeben...",
            "es": "Por favor especifica...",
            "it": "Per favore specificare..."
          },
          "otherText": {
            "default": "Other features",
            "fr": "Autres fonctionnalités",
            "de": "Andere Eigenschaften",
            "es": "Otras características",
            "it": "Altre caratteristiche"
          },
          "colCount": 2,
          "maxSelectedChoices": 3
        }
      ]
    },
    {
      "name": "page2",
      "elements": [
        {
          "type": "boolean",
          "name": "rebuy",
          "title": {
            "default": "Would you buy our product again?",
            "fr": "Achèteriez-vous à nouveau notre produit?",
            "de": "Würden Sie unser Produkt wieder kaufen?",
            "es": "¿Comprarías nuestro producto nuevamente?",
            "it": "Compreresti di nuovo il nostro prodotto?"
          }
        }
      ]
    },
    {
      "name": "page3",
      "elements": [
        {
          "type": "radiogroup",
          "name": "testimonial",
          "title": {
            "default": "Would you mind providing us a brief testimonial for the website?",
            "fr": "Accepteriez-vous de rédiger un bref commentaire pour notre site Internet?",
            "de": "Würde es Ihnen etwas ausmachen, uns ein kurzes Testimonial für die Website zu geben?",
            "es": "¿Le importaría brindarnos un breve testimonio sobre el sitio web?",
            "it": "Ti dispiacerebbe fornirci una breve testimonianza per il sito web?"
          },
          "choices": [
            {
              "value": "yes",
              "text": {
                "default": "Sure!",
                "fr": "Bien sur!",
                "de": "Sicher!",
                "es": "¡Seguro!",
                "it": "Certamente!"
              }
            },
            {
              "value": "no",
              "text": {
                "default": "No",
                "fr": "Non merci.",
                "de": "Nein",
                "es": "No",
                "it": "No"
              }
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{testimonial} = 'yes'",
          "title": {
            "default": "What is your email address?",
            "fr": "Quelle est votre adresse e-mail?",
            "de": "Wie lautet deine E-Mail Adresse?",
            "es": "¿Cuál es tu dirección de correo electrónico?",
            "it": "Qual è il tuo indirizzo e-mail?"
          },
          "validators": [
            {
              "type": "email"
            }
          ],
          "placeholder": {
            "default": "Enter your email here",
            "fr": "Veuillez saisir votre adresse e-mail ici",
            "de": "Gib deine E-Mail hier ein",
            "es": "Introduzca su correo electrónico aquí",
            "it": "Inserisci la tua email qua"
          }
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/jquery.md)


---
title: Localize a PDF Form
product: PDF Generator
description: This JavaScript demo demonstrates how to localize a PDF form by translating its content into different languages using a JSON schema, with examples available in English, German, Italian, French, and Spanish.
framework: React
source: https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Localize a PDF Form (React)

Localization capabilities enable you to adapt a PDF form to the local language of the viewer. This demo shows how to translate PDF form content to any language. English, German, Italian, French, and Spanish are available as examples. Select one of these languages from the **Form language** drop-down menu and click the **Save as PDF** button to generate a localized PDF document.

To localize a PDF form, open its JSON schema and translate visible texts in it (titles, descriptions, choice texts, placeholders). Typically, properties that specify visible texts accept string values. Instead, specify the properties with objects. Each object field should indicate a locale and the field value&mdash;a translation for this locale. Refer to the survey JSON schema (the `json.js` file) for a code example.

To generate a localized PDF form, assign a required locale code to the `locale` property of the [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. For example, the following code applies the French locale:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";
```

Alternatively, you can specify the [`locale`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#locale) property within the survey JSON schema that you pass to the `SurveyPDF` instance:

```js
const surveyJson = {
  // ...
  "locale": "fr"
}
const pdfDocOptions = { /* ... */ };
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

> Default PDF fonts support only Latin-based languages. Other languages require [custom fonts](/pdf-generator/examples/special-characters-in-pdf-form/).

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    survey.data = {
        "nps-score": 9,
        "promoter-features": [
            "performance",
            "ui"
        ],
        "rebuy": true,
        "testimonial": "yes",
        "email": "john.doe@example.org"
    };
    survey.locale = "it";
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "completedHtmlOnCondition": [
    {
      "expression": "{nps-score} <= 6 or {rebuy} = false",
      "html": {
        "default": "Thanks for your feedback! We highly value all ideas and suggestions from our customers, whether they're positive or critical. In the future, our team might reach out to you to learn more about how we can further improve our product so that it exceeds your expectations.",
        "fr": "Merci pour vos commentaires! Nous accordons une grande importance à toutes les idées et suggestions de nos clients, qu'elles soient positives ou critiques. À l'avenir, notre équipe pourrait vous contacter pour en savoir plus sur la façon dont nous pouvons encore améliorer notre produit afin qu'il dépasse vos attentes.",
        "de": "Vielen Dank für Ihr Feedback! Wir schätzen alle Ideen und Vorschläge unserer Kunden sehr, egal ob positiv oder kritisch. In Zukunft wird sich unser Team möglicherweise mit Ihnen in Verbindung setzen, um mehr darüber zu erfahren, wie wir unser Produkt weiter verbessern können, damit es Ihre Erwartungen übertrifft.",
        "es": "¡Gracias por tus comentarios! Valoramos mucho todas las ideas y sugerencias de nuestros clientes, ya sean positivas o críticas. En el futuro, nuestro equipo podría comunicarse con usted para obtener más información sobre cómo podemos mejorar aún más nuestro producto para que supere sus expectativas.",
        "it": "Grazie per il tuo feedback! Apprezziamo molto tutte le idee e i suggerimenti dei nostri clienti, siano essi positivi o critici. In futuro, il nostro team potrebbe contattarti per saperne di più su come possiamo migliorare ulteriormente il nostro prodotto in modo che superi le tue aspettative."
      }
    },
    {
      "expression": "{nps-score} = 6 or {nps-score} = 7",
      "html": {
        "default": "Thanks for your feedback. Our goal is to create the best possible product, and your thoughts, ideas, and suggestions play a major role in helping us identify opportunities to improve.",
        "fr": "Merci pour vos commentaires. Notre objectif est de créer le meilleur produit possible, et vos réflexions, idées et suggestions jouent un rôle majeur pour nous aider à identifier les opportunités d'amélioration.",
        "de": "Vielen Dank für Ihr Feedback. Unser Ziel ist es, das bestmögliche Produkt zu schaffen, und Ihre Gedanken, Ideen und Vorschläge spielen eine wichtige Rolle dabei, uns dabei zu helfen, Verbesserungsmöglichkeiten zu erkennen.",
        "es": "Gracias por tus comentarios. Nuestro objetivo es crear el mejor producto posible, y sus pensamientos, ideas y sugerencias juegan un papel importante para ayudarnos a identificar oportunidades para mejorar.",
        "it": "Grazie per il tuo feedback Il nostro obiettivo è creare il miglior prodotto possibile e i tuoi pensieri, idee e suggerimenti svolgono un ruolo importante nell'aiutarci a identificare le opportunità di miglioramento."
      }
    },
    {
      "expression": "{nps-score} >= 8",
      "html": {
        "default": "Thanks for your feedback. It's great to hear that you're a fan of our product. Your feedback helps us discover new opportunities to improve it and make sure you have the best possible experience.",
        "fr": "Merci pour vos commentaires. Nous sommes ravis d'entendre que vous avez apprécié notre produit. Vos commentaires nous aident à découvrir de nouvelles opportunités pour l'améliorer et vous assurer la meilleure expérience possible.",
        "de": "Vielen Dank für Ihr Feedback. Es ist schön zu hören, dass Sie ein Fan unseres Produkts sind. Ihr Feedback hilft uns, neue Verbesserungsmöglichkeiten zu entdecken und sicherzustellen, dass Sie das bestmögliche Erlebnis haben.",
        "es": "Gracias por tus comentarios. Es fantástico saber que eres fanático de nuestro producto. Sus comentarios nos ayudan a descubrir nuevas oportunidades para mejorarlo y asegurarnos de que tenga la mejor experiencia posible.",
        "it": "Grazie per il tuo feedback È bello sapere che sei un fan del nostro prodotto. Il tuo feedback ci aiuta a scoprire nuove opportunità per migliorarlo e assicurarci che tu abbia la migliore esperienza possibile."
      }
    }
  ],
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "rating",
          "name": "nps-score",
          "title": {
            "default": "On a scale from 0 to 10, how likely are you to recommend us to a friend or colleague?",
            "fr": "Sur une échelle de 0 à 10, quelle est la probabilité que vous recommandiez notre produit à un ami ou à un collègue?",
            "de": "Auf einer Skala von 0 bis 10, wie wahrscheinlich ist es, dass Sie uns einem Freund oder Kollegen weiterempfehlen?",
            "es": "En una escala de 0 a 10, ¿qué probabilidades hay de que nos recomiende a un amigo o colega?",
            "it": "Su una scala da 0 a 10, quanto è probabile che ci consiglieresti ad un amico o collega?"
          },
          "rateMin": 0,
          "rateMax": 10
        },
        {
          "type": "comment",
          "name": "disappointing-experience",
          "visibleIf": "{nps-score} <= 5",
          "title": {
            "default": "How did we disappoint you and what can we do to make things right?",
            "fr": "Nous n'avons pas été a la hauteur de vos attentes, comment pouvons-nous améliorer?",
            "de": "Wie haben wir Sie enttäuscht und was können wir tun, um die Dinge wieder in Ordnung zu bringen?",
            "es": "¿Cómo te decepcionamos y qué podemos hacer para arreglar las cosas?",
            "it": "In che modo ti abbiamo deluso e cosa possiamo fare per sistemare le cose?"
          },
          "maxLength": 300
        },
        {
          "type": "comment",
          "name": "improvements-required",
          "visibleIf": "{nps-score} >= 6",
          "title": {
            "default": "What can we do to make your experience more satisfying?",
            "fr": "Que pouvons-nous faire pour rendre votre expérience plus satisfaisante?",
            "de": "Was können wir tun, um Ihr Erlebnis zufriedenstellender zu gestalten?",
            "es": "¿Qué podemos hacer para que tu experiencia sea más satisfactoria?",
            "it": "Cosa possiamo fare per rendere la tua esperienza più soddisfacente?"
          },
          "maxLength": 300
        },
        {
          "type": "checkbox",
          "name": "promoter-features",
          "visibleIf": "{nps-score} >= 9",
          "title": {
            "default": "Which of the following features do you value the most?",
            "fr": "Laquelle des fonctionnalités suivantes appréciez-vous le plus ?",
            "de": "Welche der folgenden Funktionen schätzen Sie am meisten?",
            "es": "¿Cuál de las siguientes características valoras más?",
            "it": "Quale delle seguenti caratteristiche apprezzi di più?"
          },
          "description": {
            "default": "Please select no more than three features.",
            "fr": "Veuillez ne pas sélectionner plus de trois fonctionnalités.",
            "de": "Bitte wählen Sie nicht mehr als drei Funktionen aus.",
            "es": "Seleccione no más de tres funciones.",
            "it": "Seleziona non più di tre funzionalità."
          },
          "isRequired": true,
          "choices": [
            {
              "value": "performance",
              "text": {
                "default": "Performance",
                "de": "Leistung",
                "es": "Actuación",
                "it": "Prestazione"
              }
            },
            {
              "value": "stability",
              "text": {
                "default": "Stability",
                "fr": "Stabilité",
                "de": "Stabilität",
                "es": "Estabilidad",
                "it": "Stabilità"
              }
            },
            {
              "value": "ui",
              "text": {
                "default": "User interface",
                "fr": "Interface utilisateur",
                "de": "Benutzeroberfläche",
                "es": "Interfaz de usuario",
                "it": "Interfaccia utente"
              }
            },
            {
              "value": "complete-functionality",
              "text": {
                "default": "Complete functionality",
                "fr": "Ensemble des fonctionnalités",
                "de": "Vollständige Funktionalität",
                "es": "Funcionalidad completa",
                "it": "Funzionalità completa"
              }
            },
            {
              "value": "learning-materials",
              "text": {
                "default": "Learning materials (documentation, demos, code examples)",
                "fr": "Matériel d'apprentissage (documentation, démos, exemples de code)",
                "de": "Lernmaterialien (Dokumentation, Demos, Codebeispiele)",
                "es": "Materiales de aprendizaje (documentación, demostraciones, ejemplos de código)",
                "it": "Materiali didattici (documentazione, demo, esempi di codice)"
              }
            },
            {
              "value": "support",
              "text": {
                "default": "Quality support",
                "fr": "Accompagnement de qualité",
                "de": "Qualitätsunterstützung",
                "es": "Soporte de calidad",
                "it": "Supporto di qualità"
              }
            }
          ],
          "showOtherItem": true,
          "otherPlaceholder": {
            "default": "Please specify...",
            "fr": "Veuillez préciser...",
            "de": "Bitte angeben...",
            "es": "Por favor especifica...",
            "it": "Per favore specificare..."
          },
          "otherText": {
            "default": "Other features",
            "fr": "Autres fonctionnalités",
            "de": "Andere Eigenschaften",
            "es": "Otras características",
            "it": "Altre caratteristiche"
          },
          "colCount": 2,
          "maxSelectedChoices": 3
        }
      ]
    },
    {
      "name": "page2",
      "elements": [
        {
          "type": "boolean",
          "name": "rebuy",
          "title": {
            "default": "Would you buy our product again?",
            "fr": "Achèteriez-vous à nouveau notre produit?",
            "de": "Würden Sie unser Produkt wieder kaufen?",
            "es": "¿Comprarías nuestro producto nuevamente?",
            "it": "Compreresti di nuovo il nostro prodotto?"
          }
        }
      ]
    },
    {
      "name": "page3",
      "elements": [
        {
          "type": "radiogroup",
          "name": "testimonial",
          "title": {
            "default": "Would you mind providing us a brief testimonial for the website?",
            "fr": "Accepteriez-vous de rédiger un bref commentaire pour notre site Internet?",
            "de": "Würde es Ihnen etwas ausmachen, uns ein kurzes Testimonial für die Website zu geben?",
            "es": "¿Le importaría brindarnos un breve testimonio sobre el sitio web?",
            "it": "Ti dispiacerebbe fornirci una breve testimonianza per il sito web?"
          },
          "choices": [
            {
              "value": "yes",
              "text": {
                "default": "Sure!",
                "fr": "Bien sur!",
                "de": "Sicher!",
                "es": "¡Seguro!",
                "it": "Certamente!"
              }
            },
            {
              "value": "no",
              "text": {
                "default": "No",
                "fr": "Non merci.",
                "de": "Nein",
                "es": "No",
                "it": "No"
              }
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{testimonial} = 'yes'",
          "title": {
            "default": "What is your email address?",
            "fr": "Quelle est votre adresse e-mail?",
            "de": "Wie lautet deine E-Mail Adresse?",
            "es": "¿Cuál es tu dirección de correo electrónico?",
            "it": "Qual è il tuo indirizzo e-mail?"
          },
          "validators": [
            {
              "type": "email"
            }
          ],
          "placeholder": {
            "default": "Enter your email here",
            "fr": "Veuillez saisir votre adresse e-mail ici",
            "de": "Gib deine E-Mail hier ein",
            "es": "Introduzca su correo electrónico aquí",
            "it": "Inserisci la tua email qua"
          }
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vanillajs.md)


---
title: Localize a PDF Form
product: PDF Generator
description: This JavaScript demo demonstrates how to localize a PDF form by translating its content into different languages using a JSON schema, with examples available in English, German, Italian, French, and Spanish.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Localize a PDF Form (Angular)

Localization capabilities enable you to adapt a PDF form to the local language of the viewer. This demo shows how to translate PDF form content to any language. English, German, Italian, French, and Spanish are available as examples. Select one of these languages from the **Form language** drop-down menu and click the **Save as PDF** button to generate a localized PDF document.

To localize a PDF form, open its JSON schema and translate visible texts in it (titles, descriptions, choice texts, placeholders). Typically, properties that specify visible texts accept string values. Instead, specify the properties with objects. Each object field should indicate a locale and the field value&mdash;a translation for this locale. Refer to the survey JSON schema (the `json.js` file) for a code example.

To generate a localized PDF form, assign a required locale code to the `locale` property of the [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. For example, the following code applies the French locale:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
surveyPdf.locale = "fr";
```

Alternatively, you can specify the [`locale`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#locale) property within the survey JSON schema that you pass to the `SurveyPDF` instance:

```js
const surveyJson = {
  // ...
  "locale": "fr"
}
const pdfDocOptions = { /* ... */ };
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

> Default PDF fonts support only Latin-based languages. Other languages require [custom fonts](/pdf-generator/examples/special-characters-in-pdf-form/).

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "completedHtmlOnCondition": [
    {
      "expression": "{nps-score} <= 6 or {rebuy} = false",
      "html": {
        "default": "Thanks for your feedback! We highly value all ideas and suggestions from our customers, whether they're positive or critical. In the future, our team might reach out to you to learn more about how we can further improve our product so that it exceeds your expectations.",
        "fr": "Merci pour vos commentaires! Nous accordons une grande importance à toutes les idées et suggestions de nos clients, qu'elles soient positives ou critiques. À l'avenir, notre équipe pourrait vous contacter pour en savoir plus sur la façon dont nous pouvons encore améliorer notre produit afin qu'il dépasse vos attentes.",
        "de": "Vielen Dank für Ihr Feedback! Wir schätzen alle Ideen und Vorschläge unserer Kunden sehr, egal ob positiv oder kritisch. In Zukunft wird sich unser Team möglicherweise mit Ihnen in Verbindung setzen, um mehr darüber zu erfahren, wie wir unser Produkt weiter verbessern können, damit es Ihre Erwartungen übertrifft.",
        "es": "¡Gracias por tus comentarios! Valoramos mucho todas las ideas y sugerencias de nuestros clientes, ya sean positivas o críticas. En el futuro, nuestro equipo podría comunicarse con usted para obtener más información sobre cómo podemos mejorar aún más nuestro producto para que supere sus expectativas.",
        "it": "Grazie per il tuo feedback! Apprezziamo molto tutte le idee e i suggerimenti dei nostri clienti, siano essi positivi o critici. In futuro, il nostro team potrebbe contattarti per saperne di più su come possiamo migliorare ulteriormente il nostro prodotto in modo che superi le tue aspettative."
      }
    },
    {
      "expression": "{nps-score} = 6 or {nps-score} = 7",
      "html": {
        "default": "Thanks for your feedback. Our goal is to create the best possible product, and your thoughts, ideas, and suggestions play a major role in helping us identify opportunities to improve.",
        "fr": "Merci pour vos commentaires. Notre objectif est de créer le meilleur produit possible, et vos réflexions, idées et suggestions jouent un rôle majeur pour nous aider à identifier les opportunités d'amélioration.",
        "de": "Vielen Dank für Ihr Feedback. Unser Ziel ist es, das bestmögliche Produkt zu schaffen, und Ihre Gedanken, Ideen und Vorschläge spielen eine wichtige Rolle dabei, uns dabei zu helfen, Verbesserungsmöglichkeiten zu erkennen.",
        "es": "Gracias por tus comentarios. Nuestro objetivo es crear el mejor producto posible, y sus pensamientos, ideas y sugerencias juegan un papel importante para ayudarnos a identificar oportunidades para mejorar.",
        "it": "Grazie per il tuo feedback Il nostro obiettivo è creare il miglior prodotto possibile e i tuoi pensieri, idee e suggerimenti svolgono un ruolo importante nell'aiutarci a identificare le opportunità di miglioramento."
      }
    },
    {
      "expression": "{nps-score} >= 8",
      "html": {
        "default": "Thanks for your feedback. It's great to hear that you're a fan of our product. Your feedback helps us discover new opportunities to improve it and make sure you have the best possible experience.",
        "fr": "Merci pour vos commentaires. Nous sommes ravis d'entendre que vous avez apprécié notre produit. Vos commentaires nous aident à découvrir de nouvelles opportunités pour l'améliorer et vous assurer la meilleure expérience possible.",
        "de": "Vielen Dank für Ihr Feedback. Es ist schön zu hören, dass Sie ein Fan unseres Produkts sind. Ihr Feedback hilft uns, neue Verbesserungsmöglichkeiten zu entdecken und sicherzustellen, dass Sie das bestmögliche Erlebnis haben.",
        "es": "Gracias por tus comentarios. Es fantástico saber que eres fanático de nuestro producto. Sus comentarios nos ayudan a descubrir nuevas oportunidades para mejorarlo y asegurarnos de que tenga la mejor experiencia posible.",
        "it": "Grazie per il tuo feedback È bello sapere che sei un fan del nostro prodotto. Il tuo feedback ci aiuta a scoprire nuove opportunità per migliorarlo e assicurarci che tu abbia la migliore esperienza possibile."
      }
    }
  ],
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "rating",
          "name": "nps-score",
          "title": {
            "default": "On a scale from 0 to 10, how likely are you to recommend us to a friend or colleague?",
            "fr": "Sur une échelle de 0 à 10, quelle est la probabilité que vous recommandiez notre produit à un ami ou à un collègue?",
            "de": "Auf einer Skala von 0 bis 10, wie wahrscheinlich ist es, dass Sie uns einem Freund oder Kollegen weiterempfehlen?",
            "es": "En una escala de 0 a 10, ¿qué probabilidades hay de que nos recomiende a un amigo o colega?",
            "it": "Su una scala da 0 a 10, quanto è probabile che ci consiglieresti ad un amico o collega?"
          },
          "rateMin": 0,
          "rateMax": 10
        },
        {
          "type": "comment",
          "name": "disappointing-experience",
          "visibleIf": "{nps-score} <= 5",
          "title": {
            "default": "How did we disappoint you and what can we do to make things right?",
            "fr": "Nous n'avons pas été a la hauteur de vos attentes, comment pouvons-nous améliorer?",
            "de": "Wie haben wir Sie enttäuscht und was können wir tun, um die Dinge wieder in Ordnung zu bringen?",
            "es": "¿Cómo te decepcionamos y qué podemos hacer para arreglar las cosas?",
            "it": "In che modo ti abbiamo deluso e cosa possiamo fare per sistemare le cose?"
          },
          "maxLength": 300
        },
        {
          "type": "comment",
          "name": "improvements-required",
          "visibleIf": "{nps-score} >= 6",
          "title": {
            "default": "What can we do to make your experience more satisfying?",
            "fr": "Que pouvons-nous faire pour rendre votre expérience plus satisfaisante?",
            "de": "Was können wir tun, um Ihr Erlebnis zufriedenstellender zu gestalten?",
            "es": "¿Qué podemos hacer para que tu experiencia sea más satisfactoria?",
            "it": "Cosa possiamo fare per rendere la tua esperienza più soddisfacente?"
          },
          "maxLength": 300
        },
        {
          "type": "checkbox",
          "name": "promoter-features",
          "visibleIf": "{nps-score} >= 9",
          "title": {
            "default": "Which of the following features do you value the most?",
            "fr": "Laquelle des fonctionnalités suivantes appréciez-vous le plus ?",
            "de": "Welche der folgenden Funktionen schätzen Sie am meisten?",
            "es": "¿Cuál de las siguientes características valoras más?",
            "it": "Quale delle seguenti caratteristiche apprezzi di più?"
          },
          "description": {
            "default": "Please select no more than three features.",
            "fr": "Veuillez ne pas sélectionner plus de trois fonctionnalités.",
            "de": "Bitte wählen Sie nicht mehr als drei Funktionen aus.",
            "es": "Seleccione no más de tres funciones.",
            "it": "Seleziona non più di tre funzionalità."
          },
          "isRequired": true,
          "choices": [
            {
              "value": "performance",
              "text": {
                "default": "Performance",
                "de": "Leistung",
                "es": "Actuación",
                "it": "Prestazione"
              }
            },
            {
              "value": "stability",
              "text": {
                "default": "Stability",
                "fr": "Stabilité",
                "de": "Stabilität",
                "es": "Estabilidad",
                "it": "Stabilità"
              }
            },
            {
              "value": "ui",
              "text": {
                "default": "User interface",
                "fr": "Interface utilisateur",
                "de": "Benutzeroberfläche",
                "es": "Interfaz de usuario",
                "it": "Interfaccia utente"
              }
            },
            {
              "value": "complete-functionality",
              "text": {
                "default": "Complete functionality",
                "fr": "Ensemble des fonctionnalités",
                "de": "Vollständige Funktionalität",
                "es": "Funcionalidad completa",
                "it": "Funzionalità completa"
              }
            },
            {
              "value": "learning-materials",
              "text": {
                "default": "Learning materials (documentation, demos, code examples)",
                "fr": "Matériel d'apprentissage (documentation, démos, exemples de code)",
                "de": "Lernmaterialien (Dokumentation, Demos, Codebeispiele)",
                "es": "Materiales de aprendizaje (documentación, demostraciones, ejemplos de código)",
                "it": "Materiali didattici (documentazione, demo, esempi di codice)"
              }
            },
            {
              "value": "support",
              "text": {
                "default": "Quality support",
                "fr": "Accompagnement de qualité",
                "de": "Qualitätsunterstützung",
                "es": "Soporte de calidad",
                "it": "Supporto di qualità"
              }
            }
          ],
          "showOtherItem": true,
          "otherPlaceholder": {
            "default": "Please specify...",
            "fr": "Veuillez préciser...",
            "de": "Bitte angeben...",
            "es": "Por favor especifica...",
            "it": "Per favore specificare..."
          },
          "otherText": {
            "default": "Other features",
            "fr": "Autres fonctionnalités",
            "de": "Andere Eigenschaften",
            "es": "Otras características",
            "it": "Altre caratteristiche"
          },
          "colCount": 2,
          "maxSelectedChoices": 3
        }
      ]
    },
    {
      "name": "page2",
      "elements": [
        {
          "type": "boolean",
          "name": "rebuy",
          "title": {
            "default": "Would you buy our product again?",
            "fr": "Achèteriez-vous à nouveau notre produit?",
            "de": "Würden Sie unser Produkt wieder kaufen?",
            "es": "¿Comprarías nuestro producto nuevamente?",
            "it": "Compreresti di nuovo il nostro prodotto?"
          }
        }
      ]
    },
    {
      "name": "page3",
      "elements": [
        {
          "type": "radiogroup",
          "name": "testimonial",
          "title": {
            "default": "Would you mind providing us a brief testimonial for the website?",
            "fr": "Accepteriez-vous de rédiger un bref commentaire pour notre site Internet?",
            "de": "Würde es Ihnen etwas ausmachen, uns ein kurzes Testimonial für die Website zu geben?",
            "es": "¿Le importaría brindarnos un breve testimonio sobre el sitio web?",
            "it": "Ti dispiacerebbe fornirci una breve testimonianza per il sito web?"
          },
          "choices": [
            {
              "value": "yes",
              "text": {
                "default": "Sure!",
                "fr": "Bien sur!",
                "de": "Sicher!",
                "es": "¡Seguro!",
                "it": "Certamente!"
              }
            },
            {
              "value": "no",
              "text": {
                "default": "No",
                "fr": "Non merci.",
                "de": "Nein",
                "es": "No",
                "it": "No"
              }
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{testimonial} = 'yes'",
          "title": {
            "default": "What is your email address?",
            "fr": "Quelle est votre adresse e-mail?",
            "de": "Wie lautet deine E-Mail Adresse?",
            "es": "¿Cuál es tu dirección de correo electrónico?",
            "it": "Qual è il tuo indirizzo e-mail?"
          },
          "validators": [
            {
              "type": "email"
            }
          ],
          "placeholder": {
            "default": "Enter your email here",
            "fr": "Veuillez saisir votre adresse e-mail ici",
            "de": "Gib deine E-Mail hier ein",
            "es": "Introduzca su correo electrónico aquí",
            "it": "Inserisci la tua email qua"
          }
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        survey.data = {
            "nps-score": 9,
            "promoter-features": [
                "performance",
                "ui"
            ],
            "rebuy": true,
            "testimonial": "yes",
            "email": "john.doe@example.org"
        };
        survey.locale = "it";
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/how-to-localize-pdf-forms/vanillajs.md)
